# -*- coding: utf-8 -*-
"""
Created on Sat Mar 12 19:26:11 2022

@author: Fred
frederic.mandon@ac-montpellier.fr
Source principale pour les sockets + threads :
https://stackoverflow.com/questions/49742217/python-socket-threading-tkinter-how-to-know()-the-message-sender
"""

#!/usr/bin/env python3
# -*- coding: utf-8 -*-

#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from datetime import datetime
from time import time
from random import shuffle, randint
from math import floor, exp, log
import socket
import threading
import tkinter as tk

regles_init_client = "Connectez-vous au serveur en donnant son IP"

regles_init_serveur = "Démarrez le serveur, et, à l'aide de l'invite de "
regles_init_serveur += "commandes, trouvez votre IP locale et donnez-la"
regles_init_serveur += "au joueur Client"

regles_connexion = "Etablissement de la connexion : triple poignée de main "
regles_connexion += "\nNotation des drapeaux :"
regles_connexion += "\n\tSYN pour synchronisation"
regles_connexion += "\n\tACK pour accusé de réception"
regles_connexion += "\n\tACQ pour acquittement"
regles_connexion += "\nLorsque la valeur d'un drapeau n'est pas précisée dans les règles ci-dessous,"
regles_connexion += "c'est le client ou le serveur qui la choisit."
regles_connexion += "\nDans ce jeu les valeurs données par les joueurs sont entre 100 et 800."
regles_connexion += "\n1 - Le client commence et envoie un drapeau SYN, avec un numéro x."
regles_connexion += "\n2 - Le serveur répond avec un drapeau ACK de valeur x + 1, et un drapeau SYN, avec un numéro y."
regles_connexion += "\n3 - Le client renvoie un drapeau ACQ de valeur x + 1 et un drapeau ACK de valeur y + 1."

regles_echange = "Echange de données : en trois étapes"
regles_echange += "\nNotation des drapeaux : "
regles_echange += "\n\tSEQ pour numéro de séquence"
regles_echange += "\n\tACK pour accusé de réception"
regles_echange += "\nLorsque la valeur d'un drapeau n'est pas précisée dans les règles ci-dessous,"
regles_echange += "c'est le client ou le serveur qui la choisit."
regles_echange += "\nDans ce jeu les valeurs données par les joueurs sont entre 100 et 800."
regles_echange += "\nLe numéro de séquence est choisi par le serveur uniquement lors du premier envoi, voir ci-dessous."
regles_echange += "\n1 - Le serveur envoie un drapeau SEQ avec le numéro de séquence x. Les données sont envoyées automatiquement avec."
regles_echange += "\n     Lors du 1er échange, le serveur choisit ce numéro. Lors des échanges suivants, ce numéro est égal à la valeur"
regles_echange += "\n     du drapeau ACK envoyé par le client, auquel on ajoute 1"
regles_echange += "\n2 - Le client répond avec un drapeau ACK de valeur x + le nombre de caractères reçus."
regles_echange += "\nL'échange continue ainsi jusqu'à ce qu'il n'y ait plus de données à envoyer/recevoir"

regles_fin = "Fin de la connexion : quadruple poignée de mains"
regles_fin += "\nNotation des drapeaux :"
regles_fin += "\n\tFIN pour demande de fin de connexion"
regles_fin += "\n\tACK pour accusé de réception"
regles_fin += "\nLorsque la valeur d'un drapeau n'est pas précisée dans les règles ci-dessous,"
regles_fin += "c'est le client ou le serveur qui la choisit."
regles_fin += "\nDans ce jeu les valeurs données par les joueurs sont entre 100 et 800."
regles_fin += "\n1 - Le client fait une demande de fin, avec un drapeau FIN et une valeur x."
regles_fin += "\n2 - Le serveur répond avec un drapeau ACK de valeur x + 1."
regles_fin += "\n3 - Le serveur fait une demande de fin, avec un drapeau FIN et une valeur y."
regles_fin += "\n4 - Le client répond avec un drapeau ACK de valeur x + 1."

regles ={0:regles_connexion,
         1:regles_connexion,
         2:regles_connexion,
         3:regles_echange,
         4:regles_echange,
         5:regles_fin,
         6:regles_fin,
         7:regles_fin,
         8:regles_fin}

# GUI TKINTER
fenetre = tk.Tk()
fenetre.title("Client")
fenetre.configure(background='white')
largeur_ecran = fenetre.winfo_screenwidth()
hauteur_ecran = fenetre.winfo_screenheight()
b_lancement = tk.Button(fenetre, text = "", command = None)
b_quitter = tk.Button(fenetre, text = "Quitter", command = None)
b_envoyer = tk.Button(fenetre, text = "Envoyer des données", command = None)
b_effacer = tk.Button(fenetre, text = "Effacer entrée", command = None)
b_message = tk.Button(fenetre)
b_regles = tk.Button(fenetre, text = "Afficher les règles", command = None)
labels_co_s = [tk.Label(fenetre, text = "serveur") for i in range(25)]
labels_co_f = [tk.Label(fenetre, text = " "*21) for i in range(25)]
labels_co_c = [tk.Label(fenetre, text = "client") for i in range(25)]
labels_flags = [tk.Label(fenetre, text ="", bg = "lightgrey", width = 7) for i in range(6)]
labels_bouts = [tk.Entry(fenetre, bg = "lightgrey", width = 15) for i in range(6)]
entree = tk.Entry(fenetre)
entree_msg = tk.Entry(fenetre, width = 60)
c_1 = tk.Label(fenetre, text ="")
c_2 = tk.Label(fenetre, text ="Rentrez l'adresse du serveur ci-contre\net cliquez sur 'Connecter le client'")
c_3 = tk.Label(fenetre, text ="Bouts de message reçus :")
c_4 = tk.Label(fenetre, text ="Reconstituez le message :")
c_5 = tk.Label(fenetre, text ="Score :")
c_6 = tk.Label(fenetre, text ="100")
c_7 = tk.Label(fenetre, text = "")
c_8 = tk.Label(fenetre, text = "")
c_9 = tk.Label(fenetre, text = "")
sb = tk.Scrollbar(fenetre, orient = "vertical")

sb.grid(row=0, column=13, rowspan = 25, sticky = "ns")
b_lancement.grid(row = 13, column = 0, columnspan = 1, padx = 2, pady = 2,
                                sticky = "w")
b_envoyer.grid(row = 13, column = 1, columnspan = 1, padx = 2, pady = 2,
                                sticky = "w")
b_effacer.grid(row = 13, column = 2, columnspan = 1, padx = 2, pady = 2,
                                sticky = "w")
b_message.grid(row = 13, column = 3, columnspan = 1, padx = 2, pady = 2,
                                sticky = "w")
b_regles.grid(row = 13, column = 4, columnspan = 1, padx = 2, pady = 2,
                                sticky = "w")
b_quitter.grid(row = 15, column = 0, columnspan = 1, padx = 2, pady = 2,
                                sticky = "w")
c_1.grid(row = 0, column = 0, columnspan = 5, padx = 2, pady = 2,
                                sticky = "w")
c_2.grid(row = 1, column = 0, columnspan = 2, padx = 2, pady = 2,
                                sticky = "w")
c_3.grid(row = 2, column = 0, columnspan = 2, padx = 2, pady = 2,
                                sticky = "w")
c_4.grid(row = 8, column = 0, columnspan = 2, padx = 2, pady = 2,
                                sticky = "w")
c_5.grid(row = 11, column = 0, columnspan = 1, padx = 2, pady = 2,
                                sticky = "E")
c_6.grid(row = 11, column = 1, columnspan = 1, padx = 2, pady = 2,
                                sticky = "w")
entree.grid(row = 1, column = 2, columnspan = 3, padx = 2, pady = 2,
                                sticky = "w")
entree_msg.grid(row = 9, column = 0, columnspan = 5, padx = 2, pady = 2,
                                sticky = "w")
for i in range(25):
    labels_co_s[i].grid(row = i, column = 10, columnspan = 1, padx = 2, pady = 2)
    labels_co_f[i].grid(row = i, column = 11, columnspan = 1, padx = 2, pady = 2)
    labels_co_c[i].grid(row = i, column = 12, columnspan = 1, padx = 2, pady = 2)
for i in range(6):
    labels_flags[i].grid(row = i%3 + 3, column = (i//3) * 2, columnspan = 1, padx = 2, pady = 2, sticky = "E")
    labels_bouts[i].grid(row = i%3 + 3, column = (i//3) * 2 + 1, columnspan = 1, padx = 2, pady = 2, sticky = "W")
    #labels_bouts[i].insert(0, "abcdef")

# Variables globales (:-/) pour l'interface graphique
i_echange = 0
i_labels_bouts = 0
labels_bouts_serveur = [i for i in range(6)]
labels_bouts_client = labels_bouts_serveur
shuffle(labels_bouts_client)

def afficher_regles(jeu):
    texte_regles = regles[client.jeu.phase_nb]
    fenetre_fille = tk.Toplevel()      # creation de la fenetre fille
    fenetre_fille.grab_set()            # qui bloque la fenetre mere
    c_f1 = tk.Label(fenetre_fille, text = texte_regles, anchor = "w", justify = "left")
    c_f1.pack()
    jeu.score -= 1
    c_6.config(text = str(jeu.score))

def maj_gui(jeu):
    global i_labels_bouts, labels_bouts_client, i_echange

    # Mise à jour des échanges client-serveur
    chaine_drapeaux = ""
    for flag in jeu.drapeaux :
        chaine_drapeaux += str(flag) + " " + str(jeu.drapeaux[flag]) + " "
    chaine_drapeaux = chaine_drapeaux[:-1]
    nb_tirets = (21 - len(chaine_drapeaux))//2 - 1
    if jeu.phase_nb in jeu.PHASES_CLIENT :
        chaine_drapeaux = "<" + "-"*(nb_tirets - 1) + chaine_drapeaux + "-"*nb_tirets
    else :
        chaine_drapeaux = "-"*nb_tirets + chaine_drapeaux + "-"*(nb_tirets - 1) + ">"
    labels_co_s[i_echange].configure(bg = "blue", fg = "white")
    labels_co_c[i_echange].configure(bg = "green", fg = "white")
    labels_co_f[i_echange].configure(text = chaine_drapeaux)
    i_echange += 1

    # Mise à jour des bouts de messages échangés en phase 3 (envoi de données)
    if jeu.phase_nb == 3 :
        bout = jeu.bouts_msg[jeu.indice_bout]
        chaine_seq = "SEQ " + str(jeu.drapeaux["SEQ"])
        if jeu.client :
            i = labels_bouts_client[i_labels_bouts]
        else :
            i = i_labels_bouts
        i_labels_bouts += 1
        labels_flags[i].configure(text = chaine_seq)
        labels_bouts[i].insert(0, bout)

    # Vérification finale du message
    if jeu.phase_nb == 8 and jeu.client :
        b_message.configure(state = "normal", command = lambda:final_test(jeu))
        entree_msg.configure(state = "normal")
        c_2.configure(text = "Fin des échanges\nReconstituez le message")
        entree.configure(state = "disabled")
    if jeu.phase_nb == 7 and not jeu.client :
        c_2.configure(text = "Fin des échanges")
        entree.configure(state = "disabled")
    c_6.config(text = str(jeu.score))

    # Mise à jour temps de jeu
    jeu.t_fin = time()
    chaine, bonus = jeu.calcul_temps()
    c_7.configure(text = chaine)

def final_test(jeu):
    texte =  str(datetime.now())[10:-7]
    msg_final = str(entree_msg.get())
    if client.jeu.final_test(msg_final) :
        texte += " - Bravo ! Les données ont été correctement reconstituées"
    else :
        texte += " - Perdu ! les données sont mal reconstituées"
        c_6.config(text = str(client.jeu.score))
    c_1.config(text = texte)
    jeu.t_fin = time()
    chaine, bonus = jeu.calcul_temps()
    c_7.configure(text = chaine)
    score_f = jeu.score + bonus
    c_8.grid(row = 12, column = 1, columnspan = 3, padx = 2, pady = 2,
                                sticky = "w")
    texte_score = "Score : " + str(jeu.score) + " + bonus temps : "
    texte_score += str(bonus) + " = score final " + str(score_f)
    c_8.configure(text = texte_score, borderwidth=3, relief="solid")


def fenetre_debut_echange_client(chaine):
   b_lancement.configure(state = "disabled")
   b_envoyer.configure(state = "normal")
   texte = str(datetime.now())[10:-7]  + " - le client est connecté"
   c_2.config(text = "Entrez drapeaux et valeurs")
   entree.delete("0", "end")
   c_1.config(text = texte)
   for i in range(25) :
       labels_co_f[i].configure(text = "-"*21)
   c_7.grid(row = 11, column = 2, columnspan = 2, padx = 2, pady = 2,
                                sticky = "w")
   c_7.configure(text = chaine)

# FONCTIONS DE JEU

class TCPGame():
    """
    Modèle pour le portocole TCP simplifié, entre autres :
        les drapeaux sont utilisés avec des numéros :-/
        connexion : drapeaux ACK et SYN + numéros de séquence et d'acquittement
                    sauf dernière poignée de main, création d'un drapeau ACQuittement
        Le numéro de séquence est crée lors de la première phase d'envoi de données par le serveur,
        et utilisé uniquement lors de la phase d'échange de données
    """
    def __init__(self):
        self.ERREURS = {0:"Pas d'erreur",
                        1:"Mauvaise valeur du drapeau",
                        2:"Drapeau manquant",
                        3:"Drapeau inexistant",
                        4:"Mauvais nombre de drapeaux",
                        5:"Mauvais choix de drapeau",
                        6:"Un drapeau n'a pas de valeur",
                        7:"Mauvais numéro de séquence",
                        8:"Autre chose qu'un nombre a été associé à un drapeau",
                        9:"Attendez de recevoir des données avant d'en envoyer",
                        10:"Valeurs des drapeaux comprises entre 100 et 800",
                        99:"erreur due au programme"}
        self.COUT_ERREURS = {0:0, 1:2, 2:3, 3:1, 4:2, 5:3, 6:3, 7:3, 8:1,
                             9:1, 10: 0, 99:0}
        self.FLAGS = {"SYN", "ACK", "ACQ", "SEQ", "FIN"}
        self.PHASES = {0: {"SYN": None},
                       1: {"SYN": None, "ACK": None},
                       2: {"ACQ": None, "ACK": None},
                       3: {"SEQ": None},
                       4: {"ACK": None},
                       5: {"FIN": None},
                       6: {"ACK": None},
                       7: {"FIN": None},
                       8: {"ACK": None}}
        self.PHASES_NOMS = {0: "CONNEXION_CLIENT_DEMANDE",
                            1: "CONNEXION_SERVEUR_REPONSE",
                            2: "CONNEXION_CLIENT_REPONSE",
                            3: "DATA_SERVEUR_ENVOI",
                            4: "DATA_CLIENT_REPONSE",
                            33: "DATA_SERVEUR_ENVOI",
                            44: "DATA_CLIENT_REPONSE",
                            5: "FIN_CLIENT_DEMANDE",
                            6: "FIN_SERVEUR_REPONSE",
                            7: "FIN_SERVEUR_DEMANDE",
                            8: "FIN_CLIENT_REPONSE"}
        self.PHASES_CLIENT = (0, 2, 4, 5, 8)
        self.PHASES_SERVEUR = (1, 3, 6, 7)
        self.client = True              # true si client False si serveur
        self.score = 100
        self.msg = "ceci_est_un_message_de_test_de_longueur_suffisante"
        self.phase_nb = 0
        self.drapeaux = {}
        # Numéro de séquence pour l'envoi des données
        self.num_seq = 0
        self.seq_first_time = True    # le numéro de séquence ne peut être choisi que lors du premier envoi
        # Bouts du message reçu
        self.indice_bout = 0
        self.bouts_msg = [None for i in range(6)]
        self.msg_compris = False
        # durée de jeu
        self.t_debut = 0
        self.t_fin = 0
        self.duree = 0

    def check_flags(self):
        """
        Teste la validité des drapeaux et de leurs valeurs
        Renvoie un numéro d'erreur (0 si pas d'erreur)
        """
        # CHEAT CODE :
        #print("reçus : ", self.drapeaux, "\nphase-nb : ", self.phase_nb,
        #   "attendus : ", self.PHASES[self.phase_nb])

        # Récupération des drapeaux et valeurs attendues
        drapeaux_attendus = self.PHASES[self.phase_nb]
        # Nombre de drapeaux/de valeurs correct ?
        if len(self.drapeaux) != len(drapeaux_attendus) :
            return 4
        # Les drapeaux sont bien suivis d'une valeur ?
        for flag in self.drapeaux :
            if self.drapeaux[flag] is None :
                return 6
            try :
                self.drapeaux[flag]= int(self.drapeaux[flag])
                if self.drapeaux[flag] < 100 or self.drapeaux[flag] > 900:
                    return 10
            except :
                return 8
        # Nom des drapeaux existant ?
        for flag in self.drapeaux :
            if flag not in self.FLAGS :
                return 3
        # Intitulé des drapeaux corrects ?
        for flag_a in drapeaux_attendus :
            if flag_a not in self.drapeaux :
                return 5
        # Valeurs des drapeaux correctes ?
        for flag in self.drapeaux :
            if drapeaux_attendus[flag] is not None and self.drapeaux[flag] != drapeaux_attendus[flag] :
                return 1
        # Numéro de séquence correct ?
        if self.phase_nb == 3 :
            if not self.seq_first_time and self.drapeaux['SEQ'] != self.PHASES[4]['SEQ'] + 1 :
                return 7

        return 0

    def appliquer_regles(self,bout_de_msg = None):
        # codage par drapeaux.get pour le client et sinon pour le serveur
        if self.phase_nb == 0:       #Envoyés par le client
            self.PHASES[0]['SYN'] = self.drapeaux.get('SYN')
            self.PHASES[1]['ACK'] = self.drapeaux.get('SYN') + 1   #phase du serveur
            self.PHASES[2]['ACQ'] = self.drapeaux.get('SYN') + 1
        elif self.phase_nb == 1:     #Envoyés par le serveur
            self.PHASES[1]['SYN'] = self.drapeaux['SYN']      #phase du serveur
            self.PHASES[2]['ACK'] = self.drapeaux['SYN'] + 1
        elif self.phase_nb == 2 :    #Envoyés par le client
            pass                # les self.drapeaux sont déjà complétés en phase 0 et 1
        elif self.phase_nb == 3 :    #Envoyés par le serveur
            if self.seq_first_time :        # and not self.client automatiquement
                self.num_seq == self.drapeaux['SEQ']
                self.seq_first_time = False
                self.PHASES[3]['SEQ'] = self.drapeaux['SEQ']      # phase du serveur
            self.PHASES[4]['ACK'] = self.drapeaux['SEQ'] + len(bout_de_msg)
        elif self.phase_nb == 4 :    #Envoyés par le client
            self.PHASES[3]['SEQ'] =  self.PHASES[4]['ACK'] + 1
            pass                # les self.drapeaux sont déjà complétés en phase 3
        elif self.phase_nb == 5 :    #Envoyés par le client
            self.PHASES[5]['FIN'] = self.drapeaux.get('FIN')
            self.PHASES[6]['ACK'] = self.drapeaux.get('FIN') + 1   #phase du serveur
        elif self.phase_nb == 6 :    #Envoyés par le serveur
            pass                # les self.drapeaux sont déjà complétés en phase 6
        elif self.phase_nb == 7 :    #Envoyés par le serveur
            self.PHASES[7]['FIN'] = self.drapeaux['FIN']          #phase du serveur
            self.PHASES[8]['ACK'] = self.drapeaux['FIN'] + 1
        elif self.phase_nb == 8 :    #Envoyés par le client
            pass                # les drapeaux sont déjà complétés en phase 8

    def enter_the_flag(self, chaine):
        """
        Entrée des drapeaux pour envoi
        """
        self.drapeaux = {}
        chaine = chaine.split()

        # on extrait le (bout de) message reçu en phase 1 et 3 avant construction du
        # dictionnaire des drapeaux
        if self.phase_nb == 3 and len(chaine) == 5 and not self.client :
            self.bouts_msg[self.indice_bout] = chaine.pop(4)
        if self.phase_nb == 1 and len(chaine) == 5 and not self.client :
            self.msg = chaine.pop(4)
        # Construction du dictionnaire des drapeaux rentrés en deux étapes :
        # il peut y avoir une incohérence (pas de valeur pour le dernier drapeau)
        for i in range(0,len(chaine),2):
            self.drapeaux[chaine[i]] = None

        for i in range(1,len(chaine),2):
            self.drapeaux[chaine[i - 1]] = chaine[i]

        # On checke les self.ERREURS
        err_nb = self.check_flags()
        if err_nb == 0 :
            # On complète le dictionnaire des PHASES (valeurs attendues)
            # avec les règles
            if self.phase_nb == 3 :
                bout_de_msg = self.bouts_msg[self.indice_bout]
            else :
                bout_de_msg = None
            self.appliquer_regles(bout_de_msg)
            texte = str(datetime.now())[10:-7] + " - Envoi des drapeaux : " + str(chaine)
            if self.phase_nb == 3 and not self.client :
                texte = texte + " " + self.bouts_msg[self.indice_bout]
        else :
            self.score = self.score - self.COUT_ERREURS[err_nb]
            texte = str(datetime.now())[10:-7] + " - erreur : " + self.ERREURS[err_nb]
        return (err_nb, texte)

    def receive_flags(self, chaine):
        """
        Récupération des drapeaux et éventuellement des données
        La vérification de la validité du message a déjà été faite par l'expéditeur
        Il faut nénamoins enlever ce qui n'est pas drapeaux + valeurs
        """
        chaine = chaine.split()
        self.drapeaux = {chaine[0]:int(chaine[1])}
        if self.phase_nb >= 1 and self.phase_nb <= 2 :
            self.drapeaux[chaine[2]] = int(chaine[3])

        # En phase 1 le message à reconstituer est envoyé par le serveur
        if self.phase_nb == 1 and self.client :
            self.msg= chaine[4]
        # En phase 3 un bout du message est envoyé par le serveur
        bout_de_msg = ""
        if self.phase_nb == 3 and self.client :
            bout_de_msg= chaine[2]
            self.bouts_msg[self.indice_bout] = chaine[2]

        self.appliquer_regles(bout_de_msg)
        return

    def appel_regles(self):
        self.score = self.score - 1
        return None

    def check_send_ok(self) :
        # Vérifie si l'expéditeur est dans un tour où il a le droit d'expédier
        # Si oui renvoie True + "", si non renvoie False + msg d'erreur
        if self.client and self.phase_nb in self.PHASES_CLIENT :
            return (True, "")
        elif not self.client and self.phase_nb in self.PHASES_SERVEUR :
            return (True, "")
        texte = str(datetime.now())[10:-7] + " - erreur : " + self.ERREURS[9]
        self.score = self.score - self.COUT_ERREURS[9]
        return (False, texte)


    def cut_msg(self):
        pas = len(self.msg)//6
        debut = 0
        fin = pas + randint(-2,2)
        for i in range(5):
            self.bouts_msg[i] = self.msg[debut:fin]
            debut = fin
            fin = fin + pas + randint(-2,2)
        self.bouts_msg[5] = self.msg[debut:]
        return

    def final_test(self, msg_final):
        # Teste si le client a bien compris le message reçu
        if msg_final == self.msg :
            self.msg_compris = True
            return True
        else :
            self.msg_compris = False
            self.score = self.score - 10
            return False

    def test_fin_envoi_msg(self):
        if self.phase_nb == 5 and self.indice_bout < len(self.bouts_msg) - 1 :
            self.indice_bout += 1
            self.phase_nb = 3

    def calcul_temps(self):
        self.duree = int(self.t_fin - self.t_debut)
        chaine ="temps de jeu : " + str(self.duree // 60) + " mn " + str(self.duree % 60) + "s"
        if self.client :
            temps_en_plus = 45
        else :
            temps_en_plus = 0
        temps = self.duree - 300 - temps_en_plus
        k = log(100)/600
        bonus = floor(100*exp(-k*temps))
        return chaine, bonus

# CLIENT

class Client:
    def __init__(self):
        self.s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.jeu = TCPGame()
        self.jeu.client = True

    def connect(self, adresse):
        try:
            self.s.connect((adresse, 12346))
            self.jeu.phase_nb = 0
            self.jeu.t_debut = time()
            self.jeu.t_fin = time()
            chaine, bonus = self.jeu.calcul_temps()
            fenetre_debut_echange_client(chaine)
            self.receive()
        except ConnectionRefusedError:
            texte = str(datetime.now())[10:-7] + " - Le serveur est déconnecté / impossible de se connecter "
            c_1.config(text = texte)

    def receive(self):
        while True:
            data = self.s.recv(1024)
            data = data.decode()
            if len(data) == 0:
                pass
            else:
                self.jeu.receive_flags(data)
                if self.jeu.phase_nb == 1 or self.jeu.phase_nb == 3 :
                    dat = data.split()[:-1]
                    data = " ".join(dat)
                texte = str(datetime.now())[10:-7] + " - Le client reçoit les données du serveur : " + data
                c_1.config(text = texte)
                maj_gui(self.jeu)
                self.jeu.phase_nb += 1
                self.jeu.test_fin_envoi_msg()  # test de retour en phase 3



    def send(self):
        (tour_ok, texte) = self.jeu.check_send_ok()
        if tour_ok:
            reponse = str(entree.get())
            (err_nb, texte) = self.jeu.enter_the_flag(reponse)
            if err_nb == 0 :
                entree.delete("0", "end")
                try:
                    self.s.sendall(bytes(reponse.encode("utf-8")))
                    maj_gui(self.jeu)
                    self.jeu.phase_nb += 1
                    self.jeu.test_fin_envoi_msg()  # test de retour en phase 3
                except BrokenPipeError:
                    texte = str(datetime.now())[10:-7] + " - Le serveur est déconnecté"
                    self.s.close()
        c_1.config(text = texte)
        c_6.config(text = str(self.jeu.score))


client = Client()
def connect():
    adresse = entree.get()
    t1 = threading.Thread(target=lambda:client.connect(adresse))
    t1.start()

def send():
    t2 = threading.Thread(target=client.send)
    t2.start()

def clear():
    entree.delete("0", "end")

def destroy():
    client.s.close()
    fenetre.destroy()

# MAIN

if __name__ == "__main__":
    c_1.config(text = "Client non connecté")
    b_lancement.configure(text = "Connecter le client", command = connect)
    b_envoyer.configure(command = send, state = "disabled")
    b_effacer.configure(command = clear)
    b_quitter.configure(command = destroy)
    b_regles.configure(command = lambda:afficher_regles(client.jeu))
    b_message.configure(state = "disabled", text = "Vérification du message",
                        command = None)
    entree_msg.configure(state = "disabled")
    t0 = threading.Thread(target = fenetre.mainloop)
    t0.run()


